//-------------------------------------------------------------------
//
//  This code is copyright 2010 by G5 Entertainment AB.
//  Any unauthorized usage, either in part or in whole of this code
//  is strictly prohibited. Violators WILL be prosecuted to the
//  maximum extent allowed by law.
//
//-------------------------------------------------------------------
//
//         File: follow.js
//  Description: 
//       Author: Davidovich V. (ringo@g5software.com)

function subscribeBegin(_form)
{
  _form.submit.disabled = true;
  _form.email.disabled  = true;
  _form.submit.value    = lockit["submit.working"];
}

function subscribeEnd(_form, _result)
{
  if (_result == "OK" ||
      _result == "IS")
  {
    _form.submit.value = lockit["submit.done"];
    return;
  }
  else
  if (_result == "Invalid")
  {
    _form.email.value = null;
    _form.email.placeholder = lockit["email.invalid"];
  }

  _form.submit.disabled = false;
  _form.email.disabled  = false;
  _form.submit.value    = lockit["submit.tryagain"];
}

function subscribeValidate(_form)
{
  var emailPattern = /^[a-zA-Z0-9._-]+@[a-zA-Z0-9.-]+\.[a-zA-Z]{2,4}$/; 
  return emailPattern.test(_form.email.value);
}

function subscribeSubmit(_form)
{
  subscribeBegin(_form);

  if (!subscribeValidate(_form))
  {
    subscribeEnd(_form, "Invalid");
    return;
  }

  // send data
  with (new XMLHttpRequest())
  {
    var udid     = window.location.search.get("udid");
    var lang     = window.location.search.get("lang");
    var game     = window.location.search.get("game");
    var platform = window.location.search.get("os");

    open("GET", "http://xpromo.g5e.com/v1/service/subscribe.php" + 
      "?email="     + _form.email.value + 
      "&udid="      + udid + 
      "&game="      + game + 
      "&locale="    + lang +
      "&platform="  + platform);

    onreadystatechange = function()
    {
      if (readyState != 4)
        return;

      if (status == 200)
        subscribeEnd(_form, responseText);
      else
        subscribeEnd(_form, "Error");
    }
    send(null);
  }

  return;
}
