//-------------------------------------------------------------------
//
//  This code is copyright 2010 by G5 Entertainment AB.
//  Any unauthorized usage, either in part or in whole of this code
//  is strictly prohibited. Violators WILL be prosecuted to the
//  maximum extent allowed by law.
//
//-------------------------------------------------------------------
//
//         File: home.js
//  Description: 
//       Author: Davidovich V. (ringo@g5software.com)

with (window.localStorage)
{
  if (null == getItem("xpromo.home.count"))
  {
    setItem("xpromo.home.count", "4");
    setItem("xpromo.home.0.id",  "com.g5e.crystalportal2.hd");
    setItem("xpromo.home.1.id",  "com.g5e.treasures1.hd");
    setItem("xpromo.home.2.id",  "com.g5e.ts2.hd");
    setItem("xpromo.home.3.id",  "com.g5e.romanceofrome.hd");
  }
}

var homeDirective = 
{
  "a" : 
  {
    "game<-games" : 
    {
      "+@href"   : "game",
      "+img@src" : "game"
    }
  }
}

var dataHomeGallery = {};
var dataHomeThumbs  = {};

function homeInit()
{
  var games = new Array(parseInt(window.localStorage.getItem("xpromo.home.count")));
  for (var i = 0; i < games.length; i++)
  {
    var id = window.localStorage.getItem("xpromo.home." + i + ".id");
    games[i] = id;
  }

  dataHomeGallery.games = games;
  dataHomeThumbs.games  = games.concat(games.slice(0, 3));

  if (document.documentElement.className.indexOf(" mac") != -1)
  {
    window.onresize = function()
    {
      document.body.style.zoom = Math.min(
          window.innerWidth  / 1024, 
          window.innerHeight / 608
        ) * 100 + "%";
    };

    window.onresize();
  }
  else
  if (document.documentElement.className.indexOf(" android") != -1)
  {
    window.onresize = function()
    {
      document.body.style.zoom = Math.min(
          window.innerWidth  / 480, 
          window.innerHeight / 240
        ) * 100 + "%";
    };

    window.onresize();
  }
}

function homeRender() 
{	 
  homeInit();

  $p("#gallery").autoRender(dataHomeGallery, homeDirective);
  $p("#thumbs").autoRender(dataHomeThumbs, homeDirective);

  var userAgent = navigator.userAgent.toLowerCase();
  var badClient = (userAgent.indexOf("ipad")   != -1) && 
                  (userAgent.indexOf("os 3_2") != -1);

  var index     = 0;
  var images    = $p("#gallery img");
  var thumbs    = $p("#thumbs img");
  var duration  = badClient ? 0.01 : 0;
  var imgMargin = parseInt(window.getComputedStyle(thumbs[0])["margin-bottom"]);
  var imgHeight = thumbs[0].offsetHeight + imgMargin;

  show(index);
  setInterval(shift, 5000);

  duration = (userAgent.indexOf("android") != -1) ? 0 : 1;

  function shift()
  {
    index = (index + 1) % (images.length);
  	show(index);
  }

  function show(num)
  {
    var scrollPos = (num + 1) * imgHeight;

    for (i = 0; i < images.length; i++)
    {
      images[i].style["opacity"] = (i == num) ? 1 : 0;
      images[i].style["-webkit-transition-duration"] = duration + "s";
      images[i].parentNode.href  = thumbs[num].parentNode.href;
    }

    for (i = 0; i < thumbs.length; i++)
    {
      thumbs[i].style["opacity"] = 1;
      thumbs[i].style["-webkit-transition-duration"] = duration + "s";
      thumbs[i].style["-webkit-transform"] = "translateY(-" + scrollPos + "px)";
    }

    if (num == images.length - 1)
    {
      setTimeout(function()
      {
        for (i = 0; i < thumbs.length; i++)
        {
          thumbs[i].style["-webkit-transition-duration"] = "0s";
          thumbs[i].style["-webkit-transform"] = "translateY(0)";
        }
      }, 1000 * duration);
    }
  }
}
