//-------------------------------------------------------------------
//
//  This code is copyright 2010 by G5 Entertainment AB.
//  Any unauthorized usage, either in part or in whole of this code
//  is strictly prohibited. Violators WILL be prosecuted to the
//  maximum extent allowed by law.
//
//-------------------------------------------------------------------
//
//         File: lockit.js
//  Description: 
//       Author: Davidovich V. (ringo@g5software.com)

String.prototype.get = function(p)
{
  return (match = this.match(new RegExp("[?|&]?" + p + "=([^&]*)"))) ? match[1] : null;
}

var lockitXHR;

function lockitLoadLangs(_title)
{
  if (!lockitXHR)
    lockitXHR = new XMLHttpRequest();

  with (lockitXHR)
  {
    open("GET", _title + ".txt", false);
    send(null);

    if (responseText)
    {
      try
      {
        return JSON.parse(responseText.replace(/[\r\n]/g, ''));
      }
      catch (e)
      {
        console.log(e);
      }
    }
  }

  return null;
}

function lockitGetLang()
{
  var lang = window.location.search.get("lang");

  if (!lang)
    lang = window.localStorage.getItem("xpromo.lang");

  if (!lang)
  {
    if (navigator.userLanguage)
      lang = navigator.userLanguage;
    else
    if (navigator.language)
      lang = navigator.language.split("-")[0];
  }

  return lang;  
}

function lockitLoad(_title)
{
  var lang = lockitGetLang();
  var data = lockitLoadLangs(_title);
  if (data)
  {
    var result;
    if (("lang." + lang) in data)
      result = data["lang." + lang];
    else
    if ("lang.en" in data)
    {
      result = data["lang.en"];
      lang   = "en";
    }

    if (result)
      result.lang = lang;

    return result;
  }

  return null;
}

function lockitRenderData(_data)
{
  if (_data)
  {
    if ("title" in _data)
    {
      document.title = _data["title"];
      delete _data["title"];
    }

    for (var sel in _data)
    {
      var elements = document.querySelectorAll(sel);
      for (var i in elements)
        elements[i].innerHTML = _data[sel];
    }
  }

  return _data;
}

function lockitRender()
{
  return lockitRenderData(lockitLoad(document.title));
}

//
// Common utils
//

// Adds class name to element
function addClass(element, elClass) 
{
  var curr = element.className;
  if (!new RegExp(("(^|\\s)" + elClass + "(\\s|$)"), "i").test(curr)) 
  {
    element.className = curr + ((curr.length > 0) ? " " : "") + elClass;
  }
  return element;
}

// Removes class name from element
function removeClass(element, elClass) 
{
  if (elClass) 
  {
    element.className = element.className.replace(elClass, "");
  }
  else 
  {
    element.className = "";
    element.removeAttribute("class");
  }
  return element;
}
