//-------------------------------------------------------------------
//
//  This code is copyright 2010 by G5 Entertainment AB.
//  Any unauthorized usage, either in part or in whole of this code
//  is strictly prohibited. Violators WILL be prosecuted to the
//  maximum extent allowed by law.
//
//-------------------------------------------------------------------

var currentGameBoxGame = 0;
var currentGameBoxScreen = 0;
var maxGameBoxScreen = 0;
var activeItem = 1;
var nextItem = 1;
var timerID = 1;

function mainRender()
{
  var data = {};
  data.games = gamesInit(xpromoGames);
  $p(".games-box ul").autoRender(data, {
      "li" : 
      {
        "game<-games" : 
        {
          "+a@href"   : "game.id",
          ".name"     : "game.name",
          "+img@src"  : "game.id"
          //"div@style" : function(arg) { return "background-image: url('" + arg.item.id + "/icon.png')"; }
        }
      }
    });
}

$(document).ready(function()
{
  $('.games-box ul li img').eq(0).load(function()
  {
    var swipeOptions = {
        swipe: swipeEvent,
        click: clickEvent,
        threshold: 10
      };

    $('.games-box').swipe(swipeOptions);
    setWidthGamesBox();
    $('.go-next').click(function(){scrollMy('left')});
    $('.go-prev').click(function(){scrollMy('right')});

    window.onorientationchange = updateOrientation;
  });

  setTimeout(function () { timerID = scrollerByTimeOut(); }, 5000);

  updateLayout();
});

$(window).resize(updateLayout);

function updateLayout()
{
  document.body.style.zoom = (window.innerHeight / 768) * 100 + "%";
}

function swipeEvent(event, direction)
{
  scrollMy(direction);
}

function clickEvent(event, target)
{
}

function setWidthGamesBox()
{
  var widthUl      = 0;
  var widthGameBox = $('.games-box').width();
  var widthGame    = getWidthGame();

  widthUl = $('.games-box ul li').length * widthGame;
  $('.games-box ul').width(widthUl);
  currentGameBoxScreen = Math.floor(widthGame * currentGameBoxGame / widthGameBox);
  $('.games-box').scrollLeft(currentGameBoxScreen *  widthGameBox);
  currentGameBoxGame = currentGameBoxScreen *  widthGameBox / widthGame;

  var countPage = Math.ceil(widthUl / widthGameBox);
  maxGameBoxScreen = countPage - 1;

  var i;
  var tmpTxt = '';
  $('.pager ul li').remove();

  var tmp3 = $('.pager ul');
  tmp3.hide();
  for (i = 0; i < countPage; i++)
  {
    tmpTxt += '<li onclick="gotoPages(' + i + ')"></li>';
  }
  tmp3.html(tmpTxt);

  $('.pager ul li').addClass('current');
  setTimeout(function(){$('.pager ul li').removeClass('current')},100);
  setTimeout(function(){calculateCurrent()}, 150);
  setTimeout(function(){$('.pager ul').fadeIn(500)}, 170);
}

function scrollMy(direction) 
{
  if (direction == 'left')
  {
    gotoPages(currentGameBoxScreen + 1);
  }
  else
  if (direction == 'right')
  {
    gotoPages(currentGameBoxScreen - 1);
  }
}

function gotoPages(a) 
{
  var gameBox      = $('.games-box');
  var gameBoxWidth = gameBox.width();
  var scrollNext   = gameBoxWidth * a;

  if (a == maxGameBoxScreen)
  {
    var widthGame = getWidthGame();
    var widthUl   = $('.games-box ul li').length * widthGame;
    scrollNext    = widthUl - gameBoxWidth;
  }

  if (a >= 0 && a <= maxGameBoxScreen)
  {
    gameBox.animate({
        scrollLeft: scrollNext
      },500, function(){
          calculateCurrent();
        });
  }
}

function calculateCurrent() 
{
  var widthGame = getWidthGame();
  var gameBox = $('.games-box');
  var startScrollLeft = gameBox.scrollLeft();

  currentGameBoxGame   = startScrollLeft / widthGame;
  currentGameBoxScreen = Math.ceil(startScrollLeft / gameBox.width());

  var tmp3 = $('.pager ul li');
  tmp3.removeClass('current');
  tmp3.eq(currentGameBoxScreen).addClass('current');

  if(currentGameBoxScreen == 0)
  {
    $('.latest-games .go-prev').addClass('prev-disable');
  }
  else
  {
    $('.latest-games .go-prev').removeClass('prev-disable');
  }

  if(currentGameBoxScreen == maxGameBoxScreen)
  {
    $('.latest-games .go-next').addClass('next-disable');
    currentGameBoxGame = $('.games-box ul li').length - 1;
  }
  else
  {
    $('.latest-games .go-next').removeClass('next-disable');
  }
}

function updateOrientation()
{
  setTimeout('setWidthGamesBox()', 500);
}

function scrollerByTimeOut() 
{
  nextItem = (activeItem >= $('.banner-item').length) ? 1 : activeItem + 1;
  scroller(nextItem);
}

function scroller(aId) 
{
  if (activeItem != aId) 
  {
    $('#banner-item-' + activeItem).fadeOut(700);
    $('#banner-item-' + aId).fadeIn(700);
    activeItem = aId;
  }

  clearTimeout(timerID);
  timerID = setTimeout(function () 
  {
    scrollerByTimeOut()
  }, 5000);
}

function getWidthGame() 
{
  var tmp = $('.games-box ul li').eq(0);
  return tmp.width() + parseInt(tmp.css('margin-left')) + parseInt(tmp.css('margin-right'));
}
